import { useMemo } from 'react';
import { geoAlbersUsa, geoPath } from 'd3';

const projection = geoAlbersUsa()
  .scale(1000)
  .translate([500, 270]);
const path = geoPath(projection);

export const Marks = ({
  USAtlas: { states, interiors },
  data,
  colorScale,
  colorValue,
}) => (
  <g className="marks">
    {useMemo(
      () => (
        <>
          {states.features.map((feature) => (
            <path
              className="states"
              d={path(feature)}
            />
          ))}
          <path
            className="interiors"
            d={path(interiors)}
          />
        </>
      ),
      [path, states, interiors]
    )}
    {data.map((d) => {
      const [x, y] = projection([
        d.longitude,
        d.latitude,
      ]);
      return (
        <circle
          cx={x}
          cy={y}
          fill={colorScale(colorValue(d))}
        />
      );
    })}
  </g>
);
