import React, { useMemo } from 'react';
import { scaleQuantile, max } from 'd3';
import { Marks } from './Marks';

const colorValue = d => d.AQI;

export const BubbleMap = ({ data, USAtlas, filteredData }) => {
  
  const colorScale = useMemo(() => scaleQuantile()
	.domain([0, max(data, colorValue)])
	.range(["#00e400", "#70d200", "#9bbe00", "#bba800", "#d58e00", "#e97100", "#f74c00", "#ff0000"]),
    	[data, colorValue]);

  return (
    <Marks
      USAtlas={USAtlas}
      data={filteredData}
      colorScale={colorScale}
      colorValue={colorValue}
    />
  );
};
